package com.fr.plugin.pielinecomb.comp;

import com.fr.base.BaseUtils;
import com.fr.design.beans.BasicBeanPane;
import com.fr.design.gui.ibutton.UIButton;
import com.fr.design.gui.ibutton.UIToggleButton;
import com.fr.design.i18n.Toolkit;
import com.fr.general.ComparatorUtils;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.chart.VanChartAttrHelper;
import com.fr.plugin.chart.attr.axis.VanChartAxis;
import com.fr.plugin.chart.attr.plot.VanChartAxisPlot;
import com.fr.plugin.pielinecomb.ui.PieLineCombStyleAxisPane;
import com.fr.van.chart.designer.style.axis.VanChartAxisPane;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author duan.jingliang
 * @date 2022/10/20
 */
public class CustomChartAxisButtonPane extends BasicBeanPane<JSONObject> {
    private static final int B_W = 56;
    private static final int B_H = 21;
    private static final int COL_COUNT = 3;
    private static final int MAX_COUNT = 20;
    private UIButton addButton;

    private List<CustomChartAxisButtonPane.ChartAxisButton> indexList_Y = new ArrayList();
    private JPanel buttonPane;
    private PieLineCombStyleAxisPane parent;


    public CustomChartAxisButtonPane(PieLineCombStyleAxisPane var1) {
        this.parent = var1;
        this.setLayout(new BorderLayout());
        this.addButton = new UIButton(BaseUtils.readIcon("/com/fr/design/images/buttonicon/add.png"));
        JPanel var2 = new JPanel(new BorderLayout());
        var2.setBorder(BorderFactory.createEmptyBorder(0, 0, 10, 20));
        var2.add(this.addButton, "North");
        //this.addButton.setVisible(false);
        this.add(var2, "East");
        this.buttonPane = new JPanel();
        this.buttonPane.setBorder(BorderFactory.createEmptyBorder(0, 5, 10, 0));
        this.add(this.buttonPane, "Center");

        this.addButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent var1) {
                //添加Y轴
                CustomChartAxisButtonPane.this.addYAxis();
            }
        });
    }

    private void layoutPane() {
        if (this.buttonPane != null) {
            this.buttonPane.removeAll();
            this.buttonPane.setLayout(new BoxLayout(this.buttonPane, 1));
            JPanel var1 = null;
            int var3 = this.indexList_Y.size();


            for(int i = 0; i < this.indexList_Y.size(); i++) {
                if (i % 3 == 0) {
                    var1 = new JPanel(new FlowLayout(0, 0, 0));
                    this.buttonPane.add(var1);
                }

                if (var1 != null) {
                    var1.add((Component)this.indexList_Y.get(i));
                }
            }

            this.revalidate();
        }
    }

    @Override
    protected String title4PopupWindow() {
        return Toolkit.i18nText("Fine-Design_Chart_Switch_Chart");
    }

    @Override
    public void populateBean(JSONObject var1) {

        this.indexList_Y.clear();

        JSONObject axisX = var1.getJSONObject("axisX");
        CustomChartAxisButtonPane.ChartAxisButton axisXButton = new CustomChartAxisButtonPane.ChartAxisButton(axisX.getString("axisName"));
        axisXButton.setToolTipText(axisX.getString("axisName"));
        this.indexList_Y.add(axisXButton);

        JSONArray var7 = var1.getJSONArray("axisY");
        Iterator var8 = var7.iterator();

        while(var8.hasNext()) {
            JSONObject var9 = (JSONObject)var8.next();
            CustomChartAxisButtonPane.ChartAxisButton var6 = new CustomChartAxisButtonPane.ChartAxisButton(var9.getString("axisName"));
            var6.setToolTipText(var9.getString("axisName"));
            this.indexList_Y.add(var6);
        }

        this.layoutPane();
    }

    @Override
    public JSONObject updateBean() {
        return null;
    }

    public String getNewChartName(List<CustomChartAxisButtonPane.ChartAxisButton> var1, String var2) {
        int var3 = var1.size();

        while(true) {
            String var4 = var2 + var3;
            boolean var5 = false;
            Iterator var6 = var1.iterator();

            while(var6.hasNext()) {
                CustomChartAxisButtonPane.ChartAxisButton var7 = (CustomChartAxisButtonPane.ChartAxisButton)var6.next();
                if (ComparatorUtils.equals(var7.getButtonName(), var4)) {
                    var5 = true;
                    break;
                }
            }

            if (!var5) {
                return var4;
            }

            ++var3;
        }
    }

    private void addYAxis() {
        String var1 = this.getNewChartName(this.indexList_Y, VanChartAttrHelper.Y_AXIS_PREFIX);
        CustomChartAxisButtonPane.ChartAxisButton var2 = new CustomChartAxisButtonPane.ChartAxisButton(var1);
        this.indexList_Y.add(var2);
        this.parent.addAxisPane(var1);
        this.layoutPane();
    }

    private void changeAxisSelected(String var1) {
        this.parent.changeAxisSelected(var1);
    }

    private class ChartAxisButton extends UIToggleButton {
        private static final double DEL_WIDTH = 10.0D;
        private static final long serialVersionUID = -3701452534814584608L;
        private BufferedImage closeIcon = BaseUtils.readImageWithCache("com/fr/design/images/toolbarbtn/chartChangeClose.png");
        private boolean isMoveOn = false;
        private String buttonName = "";

        public ChartAxisButton(String var2) {
            super(var2);
            this.buttonName = var2;
        }

        public String getButtonName() {
            return this.buttonName;
        }

        @Override
        public Dimension getPreferredSize() {
            return new Dimension(56, 21);
        }

        private void paintDeleteButton(Graphics var1) {
            Rectangle var2 = this.getBounds();
            int var3 = (int)(var2.getWidth() - 10.0D);
            byte var4 = 1;
            var1.drawImage(this.closeIcon, var3, var4, this.closeIcon.getWidth(), this.closeIcon.getHeight(), (ImageObserver)null);
        }

        @Override
        public void paintComponent(Graphics var1) {
            super.paintComponent(var1);
            if (this.isMoveOn && this.getButtonList().size() > 1 && !VanChartAttrHelper.isDefaultAxis(this.buttonName)) {
                this.paintDeleteButton(var1);
            }

        }

        private List<CustomChartAxisButtonPane.ChartAxisButton> getButtonList() {
            return CustomChartAxisButtonPane.this.indexList_Y;
        }

        private void noSelected() {

            CustomChartAxisButtonPane.ChartAxisButton var2;
            Iterator var1 = CustomChartAxisButtonPane.this.indexList_Y.iterator();

            while(var1.hasNext()) {
                var2 = (CustomChartAxisButtonPane.ChartAxisButton)var1.next();
                var2.setSelected(false);
            }

        }

        private void checkMoveOn(boolean var1) {
            Iterator var2;
            CustomChartAxisButtonPane.ChartAxisButton var3;

            for(var2 = CustomChartAxisButtonPane.this.indexList_Y.iterator(); var2.hasNext(); var3.isMoveOn = false) {
                var3 = (CustomChartAxisButtonPane.ChartAxisButton)var2.next();
            }

            this.isMoveOn = var1;
        }

        private Rectangle2D getRectBounds() {
            return this.getBounds();
        }

        private void deleteAButton() {
            List var1 = this.getButtonList();
            if (var1.contains(this) && var1.size() > 1) {
                var1.remove(this);
                CustomChartAxisButtonPane.this.parent.delAxisPane(this.buttonName);
                //CustomChartAxisButtonPane.this.parent.removeAxis(this.buttonName);
                if (this.isSelected()) {
                    ((CustomChartAxisButtonPane.ChartAxisButton)var1.get(0)).setSelected(true);
                    CustomChartAxisButtonPane.this.changeAxisSelected(((CustomChartAxisButtonPane.ChartAxisButton)var1.get(0)).getButtonName());

                }
            }

            this.reLayoutPane();
        }

        private void reLayoutPane() {
            CustomChartAxisButtonPane.this.layoutPane();
        }

        @Override
        protected MouseListener getMouseListener() {
            return new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent var1) {
                    CustomChartAxisButtonPane.ChartAxisButton.this.mouseClick(var1);
                }
                @Override
                public void mouseEntered(MouseEvent var1) {
                    CustomChartAxisButtonPane.ChartAxisButton.this.checkMoveOn(true);
                }
                @Override
                public void mouseExited(MouseEvent var1) {
                    CustomChartAxisButtonPane.ChartAxisButton.this.checkMoveOn(false);
                }
            };
        }

        public void mouseClick(MouseEvent var1) {
            Rectangle2D var2 = this.getRectBounds();
            if (var2 != null) {
                if ((double)var1.getX() >= var2.getWidth() - 10.0D && !VanChartAttrHelper.isDefaultAxis(this.buttonName)) {
                    this.deleteAButton();
                    this.fireSelectedChanged();
                } else {
                    if (this.isEnabled()) {
                        this.noSelected();
                        CustomChartAxisButtonPane.this.changeAxisSelected(this.getButtonName());
                        this.setSelectedWithFireListener(true);
                        this.fireSelectedChanged();
                    }

                }
            }
        }
    }

}
