package com.fr.plugin.pielinecomb.data;

import com.fr.base.Utils;
import com.fr.base.chart.chartdata.TopDefinitionProvider;
import com.fr.chart.chartattr.Chart;
import com.fr.chart.chartattr.ChartCollection;
import com.fr.extended.chart.AbstractChart;
import com.fr.extended.chart.AbstractDataConfig;
import com.fr.extended.chart.DataSet;
import com.fr.plugin.pielinecomb.PieLineCombChart;
import com.fr.stable.StringUtils;

import java.util.List;

/**
 * @author duan.jingliang
 */
public class DataUtils {
    public static PieLineCombChart getSelectSubChart(ChartCollection paramChartCollection) {
        return (PieLineCombChart) getSelectedChart(PieLineCombChart.class, paramChartCollection);
    }

    public static <T extends Chart> T getSelectedChart(Class<T> paramClass, ChartCollection paramChartCollection) {
        if (paramChartCollection == null) {
            return null;
        }
        return paramChartCollection.getSelectedChart(paramClass);
    }

    public static DataSet getSingleDataSet(String paramAbstractDataType, AbstractChart paramAbstractChart) {
        ExtendedMultiDataSet localExtendedMultiDataSet = getMultiDataSet(paramAbstractChart);
        if (localExtendedMultiDataSet != null) {
            return localExtendedMultiDataSet.getSingleDataSet(paramAbstractDataType);
        }
        return null;
    }

    public static void putSingleDataSet(String paramAbstractDataType, DataSet paramDataSet, AbstractChart paramAbstractChart) {
        ExtendedMultiDataSet localExtendedMultiDataSet = getMultiDataSet(paramAbstractChart);
        if (localExtendedMultiDataSet != null) {
            localExtendedMultiDataSet.putSingleDataSet(paramAbstractDataType, paramDataSet);
        } else {
            paramAbstractChart.setFilterDefinition(new ExtendedMultiDataSet());
        }
    }

    private static ExtendedMultiDataSet getMultiDataSet(AbstractChart paramAbstractChart) {
        TopDefinitionProvider localTopDefinitionProvider = paramAbstractChart.getFilterDefinition();
        if ((localTopDefinitionProvider instanceof ExtendedMultiDataSet)) {
            return (ExtendedMultiDataSet) localTopDefinitionProvider;
        }
        return null;
    }

    public static <T extends AbstractDataConfig> T getDataConfig(String paramAbstractDataType, AbstractChart paramAbstractChart) {
        DataSet localDataSet = getSingleDataSet(paramAbstractDataType, paramAbstractChart);
        if (localDataSet == null) {
            return null;
        }
        AbstractDataConfig localAbstractDataConfig = localDataSet.getDataConfig();
        return (T) localAbstractDataConfig;
    }

    public static boolean isReportDataFieldNotSet(List<Object> paramList) {
        return (paramList.size() == 1) && (StringUtils.isEmpty(Utils.objectToString(paramList.get(0))));
    }
}
