package com.fr.plugin.pielinecomb.data;

import com.fr.extended.chart.AbstractDataConfig;
import com.fr.extended.chart.ExtendedField;
import com.fr.stable.AssistUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * @author duan.jingliang
 * @date 2022/10/19
 */
public class PieDataConfig extends AbstractDataConfig {

    private ExtendedField category = new ExtendedField();
    private ExtendedField gridline = new ExtendedField();
    private ExtendedField regioncolor = new ExtendedField();

    @Override
    protected void readAttr(XMLableReader xmLableReader) {
        readExtendedField(category, "category", xmLableReader);
        readExtendedField(gridline, "gridline", xmLableReader);
        readExtendedField(regioncolor, "regioncolor", xmLableReader);
    }

    @Override
    protected void writeAttr(XMLPrintWriter xmlPrintWriter) {
        writeExtendedField(category, "category", xmlPrintWriter);
        writeExtendedField(gridline, "gridline", xmlPrintWriter);
        writeExtendedField(regioncolor, "regioncolor", xmlPrintWriter);
    }

    @Override
    public ExtendedField[] dataSetFields() {
        return new ExtendedField[]{
                category, gridline, regioncolor
        };
    }

    @Override
    public PieDataConfig clone() throws CloneNotSupportedException {
        PieDataConfig result = (PieDataConfig)super.clone();
        result.setCategory(this.getCategory().clone());
        result.setGridline(this.getGridline().clone());
        result.setRegioncolor(this.getRegioncolor().clone());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        return super.equals(obj)
                && obj instanceof PieDataConfig
                && AssistUtils.equals(this.getCategory(), ((PieDataConfig) obj).getCategory())
                && AssistUtils.equals(this.getGridline(), ((PieDataConfig) obj).getGridline())
                && AssistUtils.equals(this.getRegioncolor(), ((PieDataConfig) obj).getRegioncolor())
                ;
    }

    public ExtendedField getCategory() {
        return category;
    }

    public void setCategory(ExtendedField category) {
        this.category = category;
    }

    public ExtendedField getGridline() {
        return gridline;
    }

    public void setGridline(ExtendedField gridline) {
        this.gridline = gridline;
    }

    public ExtendedField getRegioncolor() {
        return regioncolor;
    }

    public void setRegioncolor(ExtendedField regioncolor) {
        this.regioncolor = regioncolor;
    }
}
