package com.fr.plugin.pielinecomb.data;

import com.fr.chart.chartattr.Chart;
import com.fr.chart.chartattr.ChartCollection;
import com.fr.chart.chartdata.ReportDataDefinition;
import com.fr.chart.chartdata.TableDataDefinition;
import com.fr.design.gui.frpane.AttributeChangeListener;
import com.fr.design.i18n.Toolkit;
import com.fr.design.mainframe.chart.gui.ChartDataPane;
import com.fr.design.mainframe.chart.gui.data.NormalChartDataPane;
import com.fr.design.mainframe.chart.gui.data.ReportDataPane;
import com.fr.design.mainframe.chart.gui.data.TableDataPane;
import com.fr.design.mainframe.chart.gui.data.report.AbstractReportDataContentPane;
import com.fr.design.mainframe.chart.gui.data.table.AbstractTableDataContentPane;
import com.fr.extended.chart.*;
import com.fr.plugin.pielinecomb.PieLineCombChart;

public class PieDataPane extends NormalChartDataPane {


    public PieDataPane(AttributeChangeListener paramAttributeChangeListener, ChartDataPane paramChartDataPane) {
        super(paramAttributeChangeListener, paramChartDataPane);
    }

    protected AbstractExtendedChartReportDataPane createReportDataContentPane() {
        return new PieReportDataPane();
    }

    protected AbstractExtendedChartTableDataPane createTableDataContentPane() {
        return new PieTableDataPane();
    }

    @Override
    public String title4PopupWindow() {
        return Toolkit.i18nText("Plugin-Pielinecomb-Typepie");
    }

    @Override
    protected TableDataPane getTableDataPane(ChartDataPane chartDataPane) {
        TableDataPane tdp = new TableDataPane(chartDataPane) {
            private AbstractExtendedChartTableDataPane pane;

            @Override
            protected AbstractTableDataContentPane getContentPane(Chart paramAnonymousChart) {
                this.pane = PieDataPane.this.createTableDataContentPane();
                return this.pane;
            }

            @Override
            public void populateBean(ChartCollection paramAnonymousChartCollection) {
                AbstractChart localAbstractChart = paramAnonymousChartCollection.getSelectedChart(PieLineCombChart.class);
                if (localAbstractChart != null) {
                    DataSet localDataSet = DataUtils.getSingleDataSet(PieLineCombChart.PIE_DATA, localAbstractChart);
                    if (accept(paramAnonymousChartCollection)) {
                        populateDSName((TableDataDefinition) localDataSet);
                    }
                    this.pane.populateDataSet(localDataSet);
                }
            }

            @Override
            public void updateBean(ChartCollection paramAnonymousChartCollection) {
                AbstractChart localAbstractChart = DataUtils.getSelectSubChart(paramAnonymousChartCollection);
                ExtendedTableDataSet localExtendedTableDataSet = this.pane.updateDataSet();
                updateDSName(localExtendedTableDataSet);
                DataUtils.putSingleDataSet(PieLineCombChart.PIE_DATA, localExtendedTableDataSet, localAbstractChart);
            }

            @Override
            public boolean accept(Object paramAnonymousObject) {
                return true;
            }
        };

        return tdp;
    }

    @Override
    protected ReportDataPane getReportDataPane(ChartDataPane paramChartDataPane) {
        return new ReportDataPane(paramChartDataPane) {
            private AbstractExtendedChartReportDataPane pane;

            @Override
            protected AbstractReportDataContentPane getContentPane(Chart paramAnonymousChart) {
                this.pane = PieDataPane.this.createReportDataContentPane();
                return this.pane;
            }

            @Override
            public void populateBean(ChartCollection paramAnonymousChartCollection) {
                AbstractChart localAbstractChart = DataUtils.getSelectSubChart(paramAnonymousChartCollection);
                if (localAbstractChart != null) {
                    DataSet localDataSet = DataUtils.getSingleDataSet(PieLineCombChart.PIE_DATA, localAbstractChart);
                    this.pane.populateDataSet(localDataSet);
                }
            }

            @Override
            public void updateBean(ChartCollection paramAnonymousChartCollection) {
                AbstractChart localAbstractChart = DataUtils.getSelectSubChart(paramAnonymousChartCollection);
                DataUtils.putSingleDataSet(PieLineCombChart.PIE_DATA, this.pane.updateDataSet(), localAbstractChart);
            }

            @Override
            public boolean accept(Object paramAnonymousObject) {
                return ((paramAnonymousObject instanceof ChartCollection)) && ((DataUtils.getSingleDataSet(PieLineCombChart.PIE_DATA, DataUtils.getSelectSubChart((ChartCollection) paramAnonymousObject)) instanceof ReportDataDefinition));
            }
        };
    }
}
