package com.fr.plugin.pielinecomb.ui;

import com.fr.design.gui.ilable.UILabel;
import com.fr.design.gui.ispinner.UISpinner;
import com.fr.design.i18n.Toolkit;
import com.fr.design.layout.TableLayout;
import com.fr.design.layout.TableLayoutHelper;
import com.fr.design.style.color.ColorSelectBox;
import com.fr.json.JSONObject;
import com.fr.plugin.pielinecomb.vo.BgGridXJson;
import com.fr.plugin.pielinecomb.vo.CustomJsonObject;
import com.fr.van.chart.designer.AbstractVanChartScrollPane;
import com.fr.van.chart.designer.TableLayout4VanChartHelper;

import javax.swing.*;
import java.awt.*;

/**
 * @author duan.jingliang
 */
public class BgGridCondCreator extends AbstractVanChartScrollPane<CustomJsonObject> {

    private UISpinner valueY;
    private ColorSelectBox lineColor;


    @Override
    protected JPanel createContentPane() {
        return new ContentPane();
    }

    @Override
    public void populateBean(CustomJsonObject json) {
        JSONObject chartConf = null;
        if (null != json) {
            chartConf = json.get();
        }
        if (null != chartConf) {
            this.valueY.setValue(chartConf.getDouble("valueY"));
            this.lineColor.setSelectObject(MapUtil.toColor(chartConf.getString("lineColor")));
        }
    }

    @Override
    public CustomJsonObject updateBean() {
        JSONObject chartConf = JSONObject.create();

        chartConf.put("valueY", this.valueY.getValue());
        chartConf.put("lineColor", MapUtil.toHex(this.lineColor.getSelectObject()));

        BgGridXJson json = new BgGridXJson();
        chartConf.put("title", json.getTilte());
        json.put(chartConf);

        return json;
    }

    @Override
    protected String title4PopupWindow() {
        return Toolkit.i18nText("Plugin-BmwGantt-Cond-condTaskBgTitle");
    }

    protected class ContentPane extends JPanel {
        public ContentPane() {
            initComponents();
        }

        private void initComponents() {
            this.setLayout(new BorderLayout());

            JPanel linePane = createLinePane();

            double p = TableLayout.PREFERRED;
            double f = TableLayout.FILL;
            double[] columnSize = {f};
            double[] rowSize = {p, p, p};
            Component[][] acomponents = new Component[][]{
                    new Component[]{linePane}
            };

            JPanel panel = TableLayoutHelper.createTableLayoutPane(acomponents, rowSize, columnSize);
            this.add(panel, BorderLayout.CENTER);
            this.setVisible(true);
        }
    }

    private JPanel createLinePane() {
        this.valueY = new UISpinner(0, 999999999, 1, 100);
        this.lineColor = new ColorSelectBox(100);
        double p = TableLayout.PREFERRED;
        double f = TableLayout.FILL;
        Component[][] components = new Component[][]{
                new Component[]{new UILabel(Toolkit.i18nText("Plugin-Pielinecomb-showPieValue")), this.valueY},
                new Component[]{new UILabel(Toolkit.i18nText("Plugin-Pielinecomb-lineColor")), this.lineColor}
        };
        return TableLayout4VanChartHelper.createGapTableLayoutPane(components, new double[]{p, p, p}, new double[]{p, f});
    }


}
