package com.fr.plugin.pielinecomb.ui;

import com.fr.base.BaseFormula;
import com.fr.chart.chartattr.Plot;
import com.fr.design.beans.BasicBeanPane;
import com.fr.design.gui.controlpane.NameableCreator;
import com.fr.js.NameJavaScriptGroup;
import com.fr.plugin.pielinecomb.PieLineCombChart;
import com.fr.van.chart.custom.component.VanChartHyperLinkPane;

import java.util.Map;

public class PieLineCombHyperLink extends VanChartHyperLinkPane {
    private PieLineCombChart chart;
    private String chartType;

    public PieLineCombHyperLink(String chartType) {
        this.chartType = chartType;
    }


    public void populateBean(PieLineCombChart paramAbstractECharts) {
        this.chart = paramAbstractECharts;
        populate(paramAbstractECharts.getPlot());
    }

    public void updateBean(PieLineCombChart paramAbstractECharts) {
        update(paramAbstractECharts.getPlot());
    }

    @Override
    public NameableCreator[] createNameableCreators() {
        return super.createNameableCreators();
    }

    @Override
    public BasicBeanPane createPaneByCreators(NameableCreator nameableCreator) {
        return super.createPaneByCreators(nameableCreator);
    }

    @Override
    protected Map<String, BaseFormula> getHyperLinkEditorMap() {
        return this.chart.getHyperLinkEditorMap();
    }

    @Override
    public void refreshNameableCreator(NameableCreator[] nameableCreators) {
        super.refreshNameableCreator(nameableCreators);
    }

    @Override
    protected NameJavaScriptGroup populateHotHyperLink(Plot paramPlot) {
        return this.chart.getLinkConf().getNameJavaScriptGroup(this.chartType);
    }

    @Override
    protected void updateHotHyperLink(Plot paramPlot, NameJavaScriptGroup paramNameJavaScriptGroup) {
        this.chart.getLinkConf().setNameJavaScriptGroup(this.chartType, paramNameJavaScriptGroup);
    }
}
