package com.fr.plugin.pielinecomb.ui;

import com.fr.design.gui.frpane.AttributeChangeListener;
import com.fr.extended.chart.AbstractExtendedStylePane;
import com.fr.extended.chart.ExtendedScrollPane;
import com.fr.plugin.pielinecomb.PieLineCombChart;

import java.util.ArrayList;
import java.util.List;

/**
 * @author duan.jingliang
 * @date 2022/8/19
 */
public class PieLineCombStylePane extends AbstractExtendedStylePane<PieLineCombChart> {

    private AttributeChangeListener attributeChangeListener;

    public PieLineCombStylePane(){
        super();
    }
    public PieLineCombStylePane(AttributeChangeListener attributeChangeListener){
        super(attributeChangeListener);
        this.attributeChangeListener = attributeChangeListener;
    }

    @Override
    protected List<ExtendedScrollPane<PieLineCombChart>> initPaneList() {
        List<ExtendedScrollPane<PieLineCombChart>> list = new ArrayList<ExtendedScrollPane<PieLineCombChart>>();
        list.add(new PieLineCombStyleTitlePane());
        list.add(new PieLineCombStyleLegendPane());
        list.add(new PieLineCombStyleLabelPane());
        list.add(new PieLineCombStyleSeriesPane());
        list.add(new PieLineCombStyleAxisPane(this));
//        list.add(new PieLineCombStyleAxisXPane());
//        list.add(new PieLineCombStyleAxisYPane());
        list.add(new PieLineCombStyleBgPane());
        list.add(new PieLineCombStyleTipsPane());
        list.add(new PieLineCombStyleAnimalPane());
        return list;
    }
}
