package com.fr.plugin.pielinecomb.data;

import com.fr.chart.chartattr.ChartCollection;
import com.fr.design.gui.ibutton.UIButtonGroup;
import com.fr.design.mainframe.chart.gui.data.DataContentsPane;
import com.fr.design.mainframe.chart.gui.data.NormalChartDataPane;
import com.fr.stable.StringUtils;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.util.Iterator;
import java.util.List;

public abstract class AbstractMultiDataContentsPane extends DataContentsPane {

    private String dataType;
    private DataChartGroupPane dataChartGroupPane;

    public AbstractMultiDataContentsPane(String dataType) {
        this.dataType = dataType;
    }

    private List<NormalChartDataPane> paneList;

    protected abstract List<NormalChartDataPane> createPaneList();

    public abstract void dataPaneTabChange(String dataType);

    private List<NormalChartDataPane> getPaneList() {
        if ((this.paneList == null) || (this.paneList.size() == 0)) {
            this.paneList = createPaneList();
        }
        return this.paneList;
    }

    @Override
    public void setSupportCellData(boolean paramBoolean) {
        Iterator localIterator = getPaneList().iterator();
        while (localIterator.hasNext()) {
            NormalChartDataPane localAbstractSingleNormalChartDataPane = (NormalChartDataPane) localIterator.next();
            localAbstractSingleNormalChartDataPane.setSupportCellData(paramBoolean);
        }
    }

    @Override
    public void populate(ChartCollection paramChartCollection) {
        Iterator localIterator = getPaneList().iterator();
        while (localIterator.hasNext()) {
            NormalChartDataPane localAbstractSingleNormalChartDataPane = (NormalChartDataPane) localIterator.next();
            localAbstractSingleNormalChartDataPane.populate(paramChartCollection);
        }
        dataChartGroupPane.populateBean(this.dataType);
    }

    @Override
    public void update(ChartCollection paramChartCollection) {
        Iterator localIterator = getPaneList().iterator();
        while (localIterator.hasNext()) {
            NormalChartDataPane localAbstractSingleNormalChartDataPane = (NormalChartDataPane) localIterator.next();
            localAbstractSingleNormalChartDataPane.update(paramChartCollection);
        }
    }

    @Override
    protected JPanel createContentPane() {
        int i = getPaneList().size();
        String[] arrayOfString = new String[i];
        JPanel[] arrayOfJPanel = new JPanel[i];
        for (int j = 0; j < i; j++) {
            NormalChartDataPane normalChartDataPane = (NormalChartDataPane) getPaneList().get(j);
            arrayOfJPanel[j] = normalChartDataPane;
            arrayOfString[j] = normalChartDataPane.title4PopupWindow();
        }
        dataChartGroupPane = new DataChartGroupPane(arrayOfString, arrayOfJPanel);
        return dataChartGroupPane;
    }

    private class DataChartGroupPane extends JPanel {
        private String[] tilteNames;
        private UIButtonGroup titleGroup;
        private CardLayout dataCardLayout;
        private JPanel cardPane;

        public DataChartGroupPane(final String[] var1, final JPanel[] var2) {
            tilteNames = var1;
            titleGroup = new UIButtonGroup(var1);
            titleGroup.setSelectedIndex(0);
            dataCardLayout = new CardLayout();
            cardPane = new JPanel(dataCardLayout) {
                @Override
                public Dimension getPreferredSize() {
                    return var2[titleGroup.getSelectedIndex()].getPreferredSize();
                }
            };

            for (int var6 = 0; var6 < var2.length && var6 < var1.length; ++var6) {
                cardPane.add(var2[var6], var1[var6]);
            }

            titleGroup.addChangeListener(new ChangeListener() {
                @Override
                public void stateChanged(ChangeEvent var1x) {
                    dataCardLayout.show(cardPane, var1[titleGroup.getSelectedIndex()]);
                    DataChartGroupPane.this.tabChanged(titleGroup.getSelectedIndex());
                }
            });
            titleGroup.setBorder(this.getButtonGroupBorder());
            this.setLayout(new BorderLayout(0, 4));
            this.add(titleGroup, "North");
            this.add(cardPane, "Center");
        }

        public void populateBean(String dataType) {
            if (null != titleGroup) {
                if (StringUtils.isNotEmpty(dataType)) {
                    for (int i = 0; i < tilteNames.length; i++) {
                        if (dataType.equals(tilteNames[i])) {
                            titleGroup.setSelectedIndex(i);
                            dataCardLayout.show(cardPane, tilteNames[titleGroup.getSelectedIndex()]);
                            break;
                        }
                    }
                }
            }
        }

        protected void tabChanged(int i) {
            NormalChartDataPane normalChartDataPane = (NormalChartDataPane) getPaneList().get(i);
            AbstractMultiDataContentsPane.this.dataPaneTabChange(normalChartDataPane.title4PopupWindow());
        }

        protected Border getButtonGroupBorder() {
            return null;
        }
    }
}
